// Copyright (C) 2000 Open Source Telecom Corporation.
//  
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software 
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#include <ivrconfig.h>
#include <server.h>
#include <cc++/audio.h>

#define	P_PTHREADS
#define	P_HAS_SEMAPHORES
#define	PASN_LEANANDMEAN
#define	PASN_NOPRINTON

#ifdef	__linux__
#define	P_LINUX
#endif

#define	PBYTE_ORDER	PLITTLE_ENDIAN

#include <ptlib.h>
#include <h323.h>

class OH323Trunk;

typedef	bool (OH323Trunk::*trunkhandler_t)(TrunkEvent *event);

class OH323Trunk : private Trunk, private TimerPort
{
private:
	friend class OH323Driver;
	static char status[250];

	trunkhandler_t handler;
	time_t lastring;
	int ts;

	bool postEvent(TrunkEvent *evt);
	void putEvent(TrunkEvent *evt);
	void timerTick(void);
	void Exit(void);
	void getName(char *buffer);
	unsigned long getIdleTime(void);

	void TrunkStep(trunkstep_t step)
		{return;};

	OH323Trunk(tpport_t port, int ts);
	~OH323Trunk();
};

class OH323Config : public Keydata
{
public:
	OH323Config();

	tpport_t getFirstPort(void)
		{return atoi(getLast("first"));};

	unsigned getRTPCount(void)
		{return atoi(getLast("count"));};

	unsigned getRTPInc(void)
		{return atoi(getLast("inc"));};

	InetAddress getBindAddress(void);
};

class OH323Driver : public Driver, public OH323Config
{
private:
	OH323Trunk **ports;
	int port_count;

public:
	OH323Driver();
	~OH323Driver();

	int Start(void);
	void Stop(void);

	int getTrunkCount(void)
		{return port_count;};

	Trunk *getTrunkPort(int id);
	aaScript *getScript(void);
};

extern OH323Driver oh323ivr;
